<?php

namespace Cord;

use PDO;
use PDOException;

class DbPdo
{
    public $pdo;

    public function __construct()
    {
        $options = array(
            PDO::ATTR_ERRMODE => PDO::  ERRMODE_EXCEPTION,
            PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC,
        );
        $db = ARRAY(
            'dsn' => 'mysql:host=localhost;dbname=audio;charset=utf8',
            'username' => 'root',
            'password' => ''
        );
        try {
            $this->pdo = new PDO($db['dsn'], $db['username'], $db['password']);
        } catch (PDOException $e) {
            die('fail:' . $e->getMessage());
        }
    }

    public function fetchAll($sql)
    {
        $con = $this->pdo->prepare($sql);
        try {
            $con->execute();
            return $con->fetchAll();
        } catch (\PDOException $e) {
            die('fail:' . $e->getMessage());
        }
    }

    public function fetch($sql)
    {
        $con = $this->pdo->prepare($sql);
        try {
            $con->execute();
            return $con->fetch();
        } catch (\PDOException $e) {
            die('fail:' . $e->getMessage());
        }
    }

    public function insertAll($table, $data)
    {
        $sql = "insert into {$table} (";
        foreach ($data as $k => $v) {
            $sql .= "$k,";
        }
        $sql = substr($sql, 0, -1);
        $sql .= ") values (";
        foreach ($data as $k => $v) {
            $sql .= "?,";
        }
        $sql = substr($sql, 0, -1);
        $sql .= ")";

        $con = $this->pdo->prepare($sql);

        for ($i = 1; $i <= count($data); $i++) {
            $con->bindValue($i, array_values($data)[$i - 1]);
        }

        try {
            $con->execute();
            return true;
        } catch (PDOException $e) {
            die('fail:' . $e->getMessage());
        }
    }

    public function delete($table, $where)
    {
        $sql = "delete from {$table} where ";
        //$where=array(id=>12)
        foreach ($where as $k => $v) {
            $sql .= $k . '=' . $v;
        }
        try {
            return ($this->pdo->exec($sql));
        } catch (PDOException $e) {
            die('fail:' . $e->getMessage());
        }
    }

    public function upData($table,$where,$data)
    {
//        update album set artist_name=?,name=?,pic=? where id=?
        $sql="update {$table} set ";
        foreach($data as $k=>$v){
            $sql .= $k . '=?,' ;
        }
        $sql=substr($sql,0,-1);
        $sql .= ' where ';
        foreach($where as $k=>$v){
            $sql .= $k .'=?';
        }

        $con = $this->pdo->prepare($sql);

        for ($i = 1; $i <= count($data); $i++) {
            $con->bindValue($i, array_values($data)[$i - 1]);
        }
        $con->bindValue($i, array_values($where)[0]);

        try {
            return $con->execute();
        } catch (PDOException $e) {
            die('fail:' . $e->getMessage());
        }
    }
}